50bdb22a369d8a3f749659e252abcea0213e1ed1
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=1.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
20 #
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs
23 #
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
26 #
27
28 ##############################################################################################
29 # Global Variables
30 ##############################################################################################
31 typeset cmd="$0 $*"
32 typeset dvdname=""
33 typeset debug=""
34 typeset dest=""
35 typeset isofile=""
36 typeset vobfile=""
37 typeset dvdpath=""
38 typeset aspect=""
39 typeset SCALE=""
40 typeset CROP=""
41 typeset profile="xvidvhq"
42 typeset extension=""
43 typeset mailto=""
44 typeset default_alang="en"
45 typeset -i default_aid=128
46 typeset -i aid_override=-1
47 typeset -i force_onepass_mode=0
48 typeset -i eject_disk=1
49 typeset -i keep_isofile=0
50 typeset -i keep_vobfile=0
51 typeset -i keep_dvdfolder=0
52 typeset -i keep_intermediate_files=0
53 typeset -i make_final_dest_vob=0
54 typeset -i make_final_dest_iso=0
55 typeset -i make_final_dest_folder=0
56 typeset -i make_final_dest_comp=0
57 typeset -i errors=0
58 typeset -i show_usage=0
59 typeset -i mirror_mode=0
60 typeset -i target_bitrate=2000
61 typeset -i target_size=0
62 typeset -i audio_2ch=0
63 typeset -i invalid_feature_title=0
64 typeset -i feature_title_override=0
65 typeset -i mplayer_dumpstream_incompatibility=0
66
67 ##############################################################################
68 # Local Machine Settings:
69 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
70 # and the local conf file created by each local machine (rip_dvd.conf)
71 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
72 # This will allow you to override all the default values to meet your needs
73 # in a way that won't get clobbered when you pull updates from my GIT repo.
74 ##############################################################################
75 config="${0%/*}/rip_dvd.conf"
76
77 # The config file will be searched for in the following location order:
78 found_config=0
79
80 # 1) /path/to/rip_dvd/script/rip_dvd.conf.dist
81 [ -e "${config}.dist" ] && found_config=1 && . "${config}.dist"
82
83 # 2) /path/to/rip_dvd/script/rip_dvd.conf
84 [ -e "${config}" ] && found_config=1 && . "${config}"
85
86 # 3) /etc/rip_dvd.conf
87 [ -e "/etc/rip_dvd.conf" ] && found_config=1 && . "/etc/rip_dvd.conf"
88
89 # 4) $PWD/rip_dvd.conf
90 [ -e "$PWD/rip_dvd.conf" ] && found_config=1 && . "$PWD/rip_dvd.conf"
91
92 # Check to make sure we found the config file
93 if [ $found_config -eq 0 ]; then
94   echo "-E- Unable to find the rip_dvd.conf file: $config"
95   exit 1
96 fi
97
98 ##############################################################################################
99 # Command line processing
100 ##############################################################################################
101 while (($#)) && getopts 12mvifkxht:n:d:b:s:t:a:p:e:j:l: opt "$@"
102 do
103     case $opt in
104         (n)     dvdname=$OPTARG;;
105         (d)     dest=$OPTARG;;
106         (b)     target_bitrate=$OPTARG;;
107         (s)     target_size=$OPTARG;;
108         (2)     audio_2ch=1;;
109         (1)     force_onepass_mode=1;;
110         (v)     make_final_dest_vob=1;;
111         (i)     make_final_dest_iso=1;;
112         (f)     make_final_dest_folder=1;; 
113         (x)     make_final_dest_comp=1;;
114         (m)     mirror_mode=1;;
115         (k)     keep_intermediate_files=1;;
116         (t)     feature_title_override=$OPTARG;;
117         (a)     aspect=$OPTARG;;
118         (p)     profile=$OPTARG;;
119         (e)     extension=$OPTARG;;
120         (j)     eject_disk=$OPTARG;;
121         (l)     aid_override=$OPTARG;;
122         (w)     set -$opt;;
123         (h)     show_usage=1;;
124         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
125         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
126     esac
127 done
128
129 shift $((OPTIND-1))
130
131 function usage() {
132     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
133     echo >&2 "Revision $REV"
134     echo >&2 "Options:"
135     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
136     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
137     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
138     echo >&2 "                 2) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
139     echo >&2 "                 3) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
140     echo >&2 "                 4) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
141     echo >&2 "   -p <profile>  Specify which encoding profile to use in -x mode as shown below:"
142     echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding (default)"
143     echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding"
144     echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
145     #echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
146     #echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
147     #echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
148     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
149     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
150     echo >&2 "   -e <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
151     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
152     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
153     echo >&2 "                 The default operation is non-mirror mode where only the main"
154     echo >&2 "                 feature title will be ripped."
155     echo >&2 "   -v            Make the final image a DVD VOB file"
156     echo >&2 "   -i            Make the final image a DVD ISO file"
157     echo >&2 "   -f            Make the final image a DVD folder"
158     echo >&2 "   -x            Make the final image a compressed file based on your profile selection"
159     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
160     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
161     echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
162     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
163     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
164     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
165     echo >&2 "   -j <n>        Eject the disk:"
166     echo >&2 "                 - 0 = do not eject the disk"
167     echo >&2 "                 - 1 = eject after the entire script is done (default)"
168     echo >&2 "                 - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
169     echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
170     echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
171     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
172     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
173     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
174     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
175     echo >&2 "   -l <aid>      Specify the audio AID language ID to rip from the source DVD"
176     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
177     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
178     echo >&2 ""
179     exit 2
180 }
181
182 if (($errors)) || (($show_usage))
183 then
184   usage
185 fi
186
187 # Sanity Check - Command Line Options 
188 if [ "$dest" == "" ]; then
189   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
190   usage
191 fi
192
193 if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
194   echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
195   usage
196 fi
197
198 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
199   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
200   usage
201 fi
202
203 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
204    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
205   echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
206   usage
207 fi
208
209 if [ $mirror_mode -eq 1 ]; then
210   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
211      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
212     echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
213     usage
214   fi
215 fi
216
217 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
218 if [ "$aspect" != "" ]; then
219   echo "$aspect" | grep -q "x"
220   if [ $? == 0 ]; then
221     echo "-E- You must specify the aspect option with a value whose format is W:H"
222     exit 1
223   fi
224   echo "$aspect" | grep -q ":"
225   if [ $? != 0 ]; then
226     SCALE=",scale -zoom -sws 9 -xy $aspect"
227   else
228     SCALE=",scale=$aspect"
229   fi
230 fi
231
232
233 # Sanity Check - Key executables
234 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
235 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
236 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
237 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
238 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
239 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
240 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
241 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
242
243 ##############################################################################################
244
245 typeset -i ripdvd
246 if [ -z "$dvdname" ]; then
247
248   # make sure the DVD device is accessible
249   volname $dev > /dev/null 2>&1
250   if [ $? != 0 ]; then
251     echo "-E- Can't access the DVD device $dev"
252     exit 1
253   fi
254   # now capture the volume name from the device
255   dvdname=`volname $dev | awk '{ print $1 }'`
256   ripdvd=1
257
258 else 
259
260   # check to see if dvdname is a full path to a real directory
261   # if it is, set dvdname and dvdpath appropriately
262   if [ -d "$dvdname" ]; then
263     dvdpath="$dvdname"
264     dvdname=`basename "$dvdname"`
265     keep_dvdfolder=1
266     if [ -z "$dvdname" ]; then
267      echo "-E- Unable to extract dvdname from path: $dvdpath"
268      exit 1
269     fi
270     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
271       echo "-E- You must supply a full path to a valid DVD folder with this option"
272       exit 1
273     fi
274   fi
275
276   # Check to see if dvdname is a full path to a file
277   if [ -f "$dvdname" ]; then
278     valid_file=0
279
280     # check to see if dvdname is a full path to an MPG2 (VOB) file
281     # if it is, set dvdname and vobfile appropriately
282     file "$dvdname" | grep -q "MPEG"
283     if [ $? == 0 ]; then
284       # It is a valid MPEG2 file, now strip the extension off our dvdname
285       vobfile="$dvdname"
286       dvdname=`basename "$dvdname"`
287       dvdname=${dvdname%.[^.]*}
288       keep_vobfile=1
289       valid_file=1
290     fi
291
292     # check to see if dvdname is a full path to an ISO file
293     # if it is, set dvdname and isofile appropriately
294     file "$dvdname" | grep -q -e "ISO" -e "UDF"
295     if [ $? == 0 ]; then
296       # It is a valid ISO file, now strip the extension off our dvdname
297       isofile="$dvdname"
298       dvdname=`basename "$dvdname"`
299       dvdname=${dvdname%.[^.]*}
300       keep_isofile=1
301       valid_file=1
302     fi    
303
304     # If we didn't find a handler for the file above, complain
305     if [ $valid_file -eq 0 ]; then
306       echo "-E- Unsupported file type: $vobfile"
307       exit 1
308     fi
309
310   # Throw an error if we can't find what the -n option is pointing to
311   else 
312     echo "-E- Unable to find the directory or file specified by the '-n $dvdname' option. Please make sure the path is valid."
313     exit 1
314   fi
315
316   # Set the ripdvd flag to false since we aren't ripping a DVD disk
317   ripdvd=0
318
319   # Since we aren't ripping a DVD disk, don't eject anything either
320   eject_disk=0
321
322 fi
323
324 # remove bad characters from the dvdname
325 dvdname=${dvdname%.} # remove trailing '.' character
326
327 # add the suffix extension to the end of the dvdname
328 dvdname=$dvdname$extension
329
330 # make a "safe" dvdname (remove special characters)
331 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
332
333 # Make sure we have a non-empty dvdname
334 if [ -z "$dvdname" ]; then
335   echo "-E- unable to determine dvdname"
336   exit 1
337 fi
338
339 # make sure our vobfile value is set
340 if [ -z "$vobfile" ]; then
341   vobfile="$dest/$dvdname.VOB"
342 fi
343
344 # set up some variables to hold various logfiles
345 logfile="$logdir/$dvdname.log"
346 passlogfile="$tmpdir/$safedvdname.log"
347 ddrescuelog=`tempfile`
348 dvdauthorlog=`tempfile`
349 encodelog=`tempfile`
350 dumplog=`tempfile`
351
352 # create the tmpdir if it doesn't already exist
353 if [ ! -d "$tmpdir" ]; then
354   mkdir -p "$tmpdir"
355   if [ $? != 0 ]; then
356     echo "-E- Unable to create the tmpdir: $tmpdir"
357     exit 1
358   fi
359 fi
360
361 # create the logdir if it doesn't already exist
362 if [ ! -d "$logdir" ]; then
363   mkdir -p "$logdir"
364   if [ $? != 0 ]; then
365     echo "-E- Unable to create the logdir: $logdir"
366     exit 1
367   fi
368 fi
369
370 ##############################################################################################
371 # cleanup functions
372 ##############################################################################################
373 cleanup() { 
374   if [ $keep_intermediate_files -eq 0 ]; then
375     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
376     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
377     [[ -e "$encodelog" ]] && rm -f "$encodelog"
378     [[ -e "$dumplog" ]] && rm -f "$dumplog"
379   else
380     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
381     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
382     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
383     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
384   fi
385   echo ""
386 }
387
388 fatal_and_exit() {
389   if [[ -z "$1" ]]; then
390     msg="-E- control-c killed us"
391   else
392     msg=$1
393   fi
394   echo -e 2>&1 "$msg" | tee -a "$logfile"
395   if [[ -n "$mailto" ]]; then
396     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
397   fi
398   keep_intermediate_files=1
399   exit 1
400 }
401
402 # Call our cleanup functions on INT and EXIT signals
403 trap fatal_and_exit INT
404 trap cleanup EXIT
405
406 ##############################################################################################
407 # processing functions
408 ##############################################################################################
409
410 # encode the vob file into a compressed file format
411 function encode_vob_file {
412
413   # Set a variable that we will use later to determine if we found a handler for $profile or not
414   typeset -i found_profile=0
415
416   # For a given profile, to override the 2 pass behavior to be single pass,
417   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
418   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
419   PASSES="1 2"
420
421   # Declare our default 2 pass variables
422   passlogfile_opt="-passlogfile $passlogfile"
423   pass_opt="pass=%PASS"
424
425   # Check the global force_onepass_mode. If it is set, change our variables appropriately
426   # to force 1-pass encoding across all profiles.
427   if [ $force_onepass_mode -eq 1 ]; then
428     PASSES="2"
429     passlogfile_opt=""
430     pass_opt=""    
431   fi
432
433   # XVID profile
434   if [ "$profile" == "xvid" ] || [ "$profile" == "xvidhq" ] || [ "$profile" == "xvidvhq" ]; then
435     found_profile=1
436     final_output_file="$dest/$dvdname.avi"
437     mencoder_general_opts="$lang_opts $passlogfile_opt"
438     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
439     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
440     mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
441
442     # Very High Quality (16fps)
443     if [ "$profile" == "xvidvhq" ]; then
444       video_encoder_opts[0]="bitrate=$target_bitrate"
445       video_encoder_opts[1]="threads=$mencoder_threads"
446       video_encoder_opts[2]="chroma_opt"
447       video_encoder_opts[3]="vhq=4"
448       video_encoder_opts[4]="bvhq=1"
449       video_encoder_opts[5]="quant_type=mpeg"
450       video_encoder_opts[6]="autoaspect"
451     fi
452     # High Quality (20fps)
453     if [ "$profile" == "xvidhq" ]; then
454       video_encoder_opts[0]="bitrate=$target_bitrate"
455       video_encoder_opts[1]="threads=$mencoder_threads"
456       video_encoder_opts[2]="chroma_opt"
457       video_encoder_opts[3]="vhq=2"
458       video_encoder_opts[4]="bvhq=1"
459       video_encoder_opts[5]="quant_type=mpeg"
460       video_encoder_opts[6]="autoaspect"
461     fi
462     # Fast (28fps)
463     if [ "$profile" == "xvid" ]; then
464       video_encoder_opts[0]="bitrate=$target_bitrate"
465       video_encoder_opts[1]="threads=$mencoder_threads"
466       video_encoder_opts[2]="vhq=0"
467       video_encoder_opts[3]="turbo"
468       video_encoder_opts[4]="autoaspect"
469     fi
470
471     for OPTS in "${video_encoder_opts[@]}"; do 
472       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
473     done
474
475     if [ $audio_2ch -eq 0 ]; then
476       # These options produce good 6 channel audio for linux and windows
477       mencoder_audio_opts="-oac copy"
478       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
479       mencoder_audioch_opts[0]="-channels 6 -af channels=6"
480       mencoder_audioch_opts[1]="-af channels=6"
481       mencoder_audioch_opts[2]=""
482     else
483       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
484       mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
485       mencoder_audioch_opts[0]=""
486     fi
487  
488   fi
489
490   # MP4 encoding profiles
491   # These are currently in BETA. They don't work that great. A new recipe is needed, for the audio.
492   if [ "$profile" == "mp4" ] || [ "$profile" == "mp4hq" ] || [ "$profile" == "mp4vhq" ]; then
493     found_profile=1
494     final_output_file="$dest/$dvdname.mp4"
495     mencoder_general_opts="$lang_opts $passlogfile_opt"
496     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
497     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
498     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
499
500     # Very High Quality (6fps)
501     if [ "$profile" == "mp4vhq" ]; then
502       video_encoder_opts[0]="bitrate=$target_bitrate"
503       video_encoder_opts[1]="threads=$mencoder_threads"
504       video_encoder_opts[2]="subq=6"
505       video_encoder_opts[3]="frameref=5"
506       video_encoder_opts[4]="bframes=3"
507       video_encoder_opts[5]="8x8dct"
508       video_encoder_opts[6]="me=umh"
509       video_encoder_opts[7]="b_pyramid"
510       video_encoder_opts[8]="weight_b"
511       video_encoder_opts[9]="partitions=all" 
512     fi
513     # High Quality (13fps)
514     if [ "$profile" == "mp4hq" ]; then
515       video_encoder_opts[0]="bitrate=$target_bitrate"
516       video_encoder_opts[1]="threads=$mencoder_threads"
517       video_encoder_opts[2]="subq=5"
518       video_encoder_opts[3]="frameref=2"
519       video_encoder_opts[4]="bframes=3"
520       video_encoder_opts[5]="8x8dct"
521       video_encoder_opts[6]="b_pyramid"
522       video_encoder_opts[7]="weight_b"
523     fi
524     # Fast (17fps)
525     if [ "$profile" == "mp4" ]; then
526       video_encoder_opts[0]="bitrate=$target_bitrate"
527       video_encoder_opts[1]="threads=$mencoder_threads"
528       video_encoder_opts[2]="subq=4"
529       video_encoder_opts[3]="bframes=2"
530       video_encoder_opts[4]="b_pyramid"
531       video_encoder_opts[5]="weight_b"
532     fi
533
534     for OPTS in "${video_encoder_opts[@]}"; do
535       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
536     done
537
538     if [ $audio_2ch -eq 0 ]; then
539       # These options produce good 6 channel audio for linux and windows
540       #mencoder_audio_opts="-oac copy"
541       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
542       #mencoder_audioch_opts[0]="-channels 6 -af channels=6"
543       #mencoder_audioch_opts[1]="-af channels=6"
544       #mencoder_audioch_opts[2]=""
545       mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
546       mencoder_audioch_opts[0]="-channels 6 -srate 48000 -af volnorm=1"
547     else
548       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
549       #mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
550       #mencoder_audioch_opts[0]=""
551       mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
552       mencoder_audioch_opts[0]="-channels 2 -srate 48000 -af volnorm=1"
553     fi
554
555   fi
556
557   # iphone and ipod MP4 profiles
558   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
559     found_profile=1
560     if [ "$profile" == "iphone" ]; then
561       # SCALE: 480x320
562       # scale width to 480, set height appropriately, but keep a multiple of 16
563       #SCALE=",scale=480:-10"
564       # scale the video down however far is necessary to fit in 480x320
565       SCALE=",dsize=480:320:0,scale=-8:-8"
566     else
567       # SCALE: 320x240
568       # scale width to 320, set height appropriately, but keep a multiple of 16
569       #SCALE=",scale=320:-10"
570       # scale the video down however far is necessary to fit in 320x240
571       SCALE=",dsize=320:240:0,scale=-8:-8"
572     fi
573     final_output_file="$dest/$dvdname.mp4"
574     mencoder_general_opts="$lang_opts $passlogfile_opt"
575     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
576     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
577     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
578     video_encoder_opts[0]="bitrate=$target_bitrate"
579     video_encoder_opts[1]="threads=$mencoder_threads"
580     video_encoder_opts[2]="vbv_maxrate=1500"
581     video_encoder_opts[3]="vbv_bufsize=2000"
582     video_encoder_opts[4]="nocabac"
583     video_encoder_opts[5]="me=umh"
584     video_encoder_opts[6]="subq=6"
585     video_encoder_opts[7]="frameref=6"
586     video_encoder_opts[8]="trellis=1"
587     video_encoder_opts[9]="level_idc=30"
588     video_encoder_opts[10]="global_header"
589     video_encoder_opts[11]="bframes=0"
590     video_encoder_opts[12]="partitions=all"
591     for OPTS in "${video_encoder_opts[@]}"; do 
592       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
593     done
594
595     mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
596     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
597   fi
598
599   if [ $found_profile -eq 0 ]; then
600     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
601   fi
602
603   # Do not edit this line. $mencoder_video_encoder_opts must be last
604   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
605   mencoder_retval=0
606
607   for PASS in $PASSES
608   do 
609     # Set some options based on which pass we are in
610     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
611     [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
612     [ $PASS -eq 1 ] && output_file="/dev/null"
613     [ $PASS -eq 2 ] && output_file="$final_output_file"
614   
615     # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
616     for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
617     do
618       echo -e "   Encoding pass $PASS"
619       echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
620       mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
621       mencoder_retval=$? 
622       grep -q "\[channels\] Invalid" $encodelog
623       if [ $? != 0 ]; then          
624         break;
625       else
626         echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
627       fi
628     done
629       
630     if [ $mencoder_retval != 0 ]; then
631       fatal_and_exit "-E- Unhandled mencoder error"
632     fi
633
634     # Concatenate the encode log to our main log file, greping out unwanted lines
635     cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
636
637   done
638 }
639
640 function make_dvd_iso_image {
641
642   isofile="$1"
643
644   # check to see if we have a dvdpath to rip from instead of $dev
645   if [ -z "$dvdpath" ]; then
646     # load the CSS codes in the DVD drive 
647     lsdvd $dev >> "$logfile"
648     if [ $? != 0 ]; then
649       fatal_and_exit "-E- lsdvd $dev failed" 
650     fi
651
652     # read the DVD, ignoring/skipping CRC errors
653     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
654     if [ $? != 0 ]; then
655       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
656     fi
657     cat "$ddrescuelog" >> "$logfile"
658   else
659     # rip from a path instead
660     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
661   fi
662 }
663
664 function make_dvd_iso_image_from_folder {
665   
666   src="$1"
667   dst="$2"
668   handle_error=$3
669   
670   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
671
672   # make an iso image out of our directory
673   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
674   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
675
676   # set the audio languages from the iso if it exists and is non-zero in size
677   if [ -s "$dst" ]; then
678     get_feature_title "$dst"
679     get_audio_id_from_iso "$dst"
680   fi
681
682   # make sure we were able to create the iso image from the folder given to us
683   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
684     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
685     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
686     # remove the bad iso file
687     [[ -e "$dst" ]] && rm -f "$dst"
688     # get the feature title from the DVD folder
689     get_feature_title "$dvdpath"
690     # create our main VOB file from the ISO
691     create_main_vob_with_mplayer "$dvdpath" 
692     # get our audio id from the VOB file
693     get_audio_id_from_vob "$vobfile"
694   fi
695 }
696
697 function make_dvdbackup_folder_image {
698   # extract the feature title from the DVD image
699   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
700   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
701   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
702   if [ $? != 0 ]; then
703     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
704   fi
705 }
706
707 function make_dvdauthor_folder_image {
708   # create a new DVD video of the feature title
709   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
710   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
711   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
712   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
713
714   # There is a chance that dvdauthor won't like some of the VOBs.
715   # We can't tell ahead of time which ones it will choke on. 
716   # So, we need to run it over and over again until it can process
717   # all the VOBs. If it can't handle one of them, run it through
718   # mencoder to fix it and try again. These errors are typically
719   # present due to the copy protection that ddrescue removed.
720   grep -q "SCR moves" $dvdauthorlog
721   while [ $? == 0 ]; do
722     # fix bad vobs that get the "SCR moves backwards" error:
723     #  STAT: Processing VTS_01_0.VOB...
724     #  ERR:  SCR moves backwards, remultiplex input.
725     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
726     if [[ ! -f "$badvob" ]]; then
727       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
728     fi
729     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
730     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
731     mv -f $badvob.fixed $badvob
732     echo "-> Creating DVD video $dest/$dvdname"
733     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
734     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
735     grep -q "SCR moves" $dvdauthorlog
736   done
737 }
738
739 function get_feature_title {
740   source="$1"
741   # if a feature title was given on the command line, use it
742   if [ $feature_title_override -ne 0 ]; then
743     feature_title=$feature_title_override
744     return 0
745   fi
746   # otherwise, use lsdvd to figure it out
747   if [ $ripdvd -eq 1 ]; then
748     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
749   else 
750     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
751   fi
752 }
753
754 function create_main_vob_with_cat {
755   # cd to the feature title DVD folder
756   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
757   if [ $? != 0 ]; then
758     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
759   fi
760
761   # concatenate all the VOBs together into 1 giant VOB
762   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
763   cat $vobs > "$tmpdir/$dvdname.VOB"
764
765   # cd back to the dir we started from
766   popd > /dev/null 2>&1
767 }
768
769 function create_main_vob_with_mplayer {
770
771   # argument processing  
772   source="$1"
773   remove_dumplog=$2
774
775   # make sure we have a valid feature title
776   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
777     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
778   fi
779
780   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
781   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
782     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
783     msg="$msg We also detected another condition that requires us to use dumpstream. "
784     msg="$msg\n    Unable to rip this DVD in the mode you requested."
785     fatal_and_exit "$msg"
786   fi
787
788   # use mplayer to create the main VOB file
789   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
790   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
791   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
792   if [ $? != 0 ]; then
793     cat $dumplog | grep -v "^A:" >> "$logfile"
794     fatal_and_exit "-E- Mplayer Failed"
795   fi
796   cat $dumplog | grep -v "^A:" >> "$logfile"
797   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
798 }
799
800 function get_audio_id_from_iso {
801   # Adjust our audio ID to find the english audio stream
802   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
803   iso="$1"
804   aidcheck=`tempfile`
805   aid=$default_aid
806   alang=$default_alang
807   if [ $aid_override -lt 0 ]; then 
808     mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
809     grep -q "aid: $aid" $aidcheck
810     while [ $? == 1 ] && [ $aid -lt 159 ]; do
811       (( aid = aid + 1 ))
812       grep -q "aid: $aid" $aidcheck
813     done
814     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
815   else
816     aid=$aid_override
817   fi
818   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
819   # mencoder default DVD audio track language selection (english)
820   lang_opts="-aid $aid -alang $alang"
821 }
822
823 function get_crop_from_iso { 
824   FRAMES=10000
825   echo "-> Detecting black frame border crop value from ISO file"
826   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
827   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
828   [[ -e "md5sums" ]] && rm -f "md5sums"
829   CROP=`cat $dumplog | grep CROP | tail -1`
830   echo "   Found crop value of $CROP" >> "$logfile"
831   CROP=${CROP#* crop=}
832   CROP=${CROP%%\).*}
833   typeset -i CROPCHECK
834   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
835   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
836   if [ -z "$CROP" ]; then
837     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
838     return
839   fi
840   if [ $CROPCHECK -lt 0 ]; then 
841     CROP=""
842   else 
843     CROP=",crop=$CROP"
844   fi
845   echo "   Setting mencoder crop filter to: $CROP"
846 }
847
848 function get_crop_from_vob { 
849   FRAMES=10000
850   echo "-> Detecting black frame border crop value from VOB file"
851   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
852   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
853   [[ -e "md5sums" ]] && rm -f "md5sums"
854   CROP=`cat $dumplog | grep CROP | tail -1`
855   echo "   Found crop value of $CROP" >> "$logfile"
856   CROP=${CROP#* crop=}
857   CROP=${CROP%%\).*}
858   typeset -i CROPCHECK
859   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
860   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
861   if [ -z "$CROP" ]; then
862     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
863     return
864   fi
865   if [ $CROPCHECK -lt 0 ]; then 
866     CROP=""
867   else 
868     CROP=",crop=$CROP"
869   fi
870   echo "   Setting mencoder crop filter to: $CROP"
871 }
872
873 function get_audio_id_from_vob {
874   # Adjust our audio ID to find the english audio stream
875   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
876   vob="$1"
877   aidcheck=`tempfile`
878   aid=$default_aid
879   alang=$default_alang
880   if [ $aid_override -lt 0 ]; then 
881     mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
882     grep -q "Found audio stream: $aid" $aidcheck
883     while [ $? == 1 ] && [ $aid -lt 159 ]; do
884       (( aid = aid + 1 ))
885       grep -q "Found audio stream: $aid" $aidcheck
886     done
887     [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
888   else 
889     aid=$aid_override
890   fi
891   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
892   # mencoder default DVD audio track language selection (english)
893   lang_opts="-aid $aid -alang $alang"
894 }
895
896 function check_vob_for_corrupted_start {
897   # check to see if the beginning of the DVD has a form of copy protection
898   # where they have deliberately broken the first X number of frames of the DVD.
899   # If we don't skip these, our resulting VOB file will not play.
900   badvobcheck=`tempfile`
901   endpos=360
902   skip=0
903   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
904   if [ $? != 0 ]; then
905     fatal_and_exit "-E- Mencoder Failed"
906   fi
907   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
908   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
909     (( skip = skip + 5 ))
910     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
911     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
912     if [ $? != 0 ]; then
913       fatal_and_exit "-E- Mencoder Failed"
914     fi
915     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
916   done
917   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
918
919   # cat the giant VOB into mencoder to create a playable VOB file
920   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
921   if [ $? != 0 ]; then
922     fatal_and_exit "-E- Mencoder Failed"
923   fi
924 }
925
926 function check_vob_for_completeness {
927   # check to make sure we got out a complete VOB.
928   # there is another kind of copy protection where the VOB's may
929   # have "MPG EOF" frames in the middle of the stream. 
930   # this causes mencoder to not process the entire VOB, and exit without any errors.
931   # detect this by seeing how much smaller the dst vob is from the src vob.
932   MAX_FILESIZE_DELTA_PERCENT=70
933   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
934   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
935   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
936   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
937     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
938     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
939     create_main_vob_with_mplayer "$isofile"
940     [[ -e "$dumplog" ]] && rm -f $dumplog
941     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
942     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
943     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
944       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
945     fi
946   fi
947 }
948
949 function check_vob_for_too_many_video_packets {
950   # If our earlier algorithm to work around this failed, throw an error.
951   # check to see if this DVD has a protection scheme we don't know how to work around
952   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
953   # for some reason, the video is black, while the audio rolls, then the video finally comes
954   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
955   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
956   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
957   grep -q "Too many video packets in the buffer:" "$logfile"
958   if [ $? == 0 ]; then
959     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
960     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
961     create_main_vob_with_mplayer "$isofile"
962     grep -q "Too many video packets in the buffer:" $dumplog
963     if [ $? == 0 ]; then
964       [[ -e "$dumplog" ]] && rm -f $dumplog
965       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
966     fi
967     [[ -e "$dumplog" ]] && rm -f $dumplog
968   fi
969 }
970
971 function check_vob_for_a52_crc_errors {
972   # Let's see if we can playback our newly created VOB file without any errors.
973   # if there are issues, let's detect them now, and try to recreate the VOB
974   # there are some forms of copy protection that have missed above, that evidence
975   # themselves when we try to playback the VOB file. This was added to deal with
976   # the "a52: CRC check failed" copy protection scheme.
977   MAX_ERRORS=10
978   ENDPOS=120
979   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
980   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
981   cat $dumplog | grep -v "^A:" >> "$logfile"
982   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
983   if [ $errors -gt $MAX_ERRORS ]; then
984     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
985     create_main_vob_with_mplayer "$isofile"
986     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
987     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
988     if [ $? != 0 ]; then
989       cat $dumplog | grep -v "^A:" >> "$logfile"
990       fatal_and_exit "-E- Mplayer Failed"
991     fi
992     cat $dumplog | grep -v "^A:" >> "$logfile"
993     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
994     if [ $errors -gt $MAX_ERRORS ]; then
995       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
996     fi
997   fi
998   [[ -e "$dumplog" ]] && rm -f $dumplog
999 }
1000
1001 function calculate_bitrate_from_target_size {
1002   # determine what our bitrate needs to be if a target size was specified instead
1003   if [ $target_size -ne 0 ]; then
1004     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
1005     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
1006     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
1007   fi
1008 }
1009
1010 function create_dvdauthor_dvd_xml_file {
1011   # make a dvdauthor xml menu file to create a valid DVD video from 
1012   # this script does a good job, but we'll still need to clean it up a bit after it runs
1013   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
1014   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
1015   if [ $? != 0 ]; then
1016     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
1017   fi
1018
1019   # replace the first line of the xml file to remove the bad dest path
1020   awk -v line=1 -v new_content="<dvdauthor>" '{
1021     if (NR == line) {
1022       print new_content;
1023     } else {
1024       print $0;
1025     }
1026   }' dvd.xml > dvd.xml.new
1027   mv -f dvd.xml.new dvd.xml
1028   if [ $? != 0 ]; then
1029     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1030   fi
1031
1032   # remove the "<video " property line from the xml file
1033   cat dvd.xml | grep -v "<video" > dvd.xml.new
1034   mv -f dvd.xml.new dvd.xml
1035   if [ $? != 0 ]; then
1036     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1037   fi
1038   
1039   # remove the extra <pgc>..</pgc> pairs
1040   cat dvd.xml | awk 'BEGIN {x=1}
1041   {
1042     if ($0~"</pgc>") {x=0}
1043     if (x==1) {print $0}
1044     if ($0~"<pgc>") {x=1}
1045   }' > dvd.xml.new
1046   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
1047   mv -f dvd.xml.new dvd.xml
1048   if [ $? != 0 ]; then
1049     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1050   fi
1051
1052   # remove the VTS_*_0.VOB file as this is just the main menu video clip
1053   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
1054   mv -f dvd.xml.new dvd.xml
1055   if [ $? != 0 ]; then
1056     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1057   fi
1058 }
1059
1060 function check_for_mplayer_dumpstream_incompatibility {
1061
1062   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
1063
1064   if [ ! -e "$vobfile" ]; then
1065     # mplayer dumpstream does not work on DVDs that obscure the feature title.
1066     # A DVD that has 99 titles, where the longest title isn't the main feature
1067     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
1068     # out what the feature title is. This script will run through that flow if we
1069     # set use_mplayer_dumpstream to 0. Check for this here.
1070     if [ $ripdvd -eq 1 ]; then
1071       lsdvd $dev | grep -q "Title: 99"
1072     else
1073       lsdvd "$isofile" | grep -q "Title: 99"
1074     fi
1075     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
1076     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
1077       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
1078         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
1079         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1080         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
1081         invalid_feature_title=1
1082       else 
1083         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
1084         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
1085         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1086         use_mplayer_dumpstream=0
1087         invalid_feature_title=1
1088       fi
1089       return
1090     fi
1091   fi
1092
1093   # There is another form of protection that causes the mplayer dumpstream to fail. 
1094   # This can be detected by telling mplayer to parse the VOB file by copying its audio
1095   # video streams to a dummy output file (/dev/null). Do that here to check for that 
1096   # problem before continuing.
1097   if [ -e "$vobfile" ]; then
1098     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
1099     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
1100     grep -q "Too many audio packets in the buffer" $dumplog
1101     if [ $? == 0 ]; then
1102       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
1103       use_mplayer_dumpstream=0
1104       mplayer_dumpstream_incompatibility=1
1105     fi
1106     [[ -e "$dumplog" ]] && rm -f $dumplog
1107   fi
1108 }
1109
1110 function fill_mythvideo_metadata {
1111
1112   # This function must be passed the filename as an argument
1113   # The filename must be a full path to the file
1114   filename="$1"
1115
1116   # Make sure the fill mythvideo metadata option has been set to 1
1117   if [ $fill_mythvideo_metadata -eq 0 ]; then
1118     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1119     return 0
1120   fi
1121
1122   # If the fill mythvideo metadata script is present, run it
1123   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1124   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1125     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1126     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1127   else
1128     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1129     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1130   fi
1131 }
1132
1133 # remove the intermediate VOB file
1134 function remove_intermediate_vob_file {
1135   if [ $keep_intermediate_files -eq 0 ]; then
1136     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1137   else
1138     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1139   fi
1140 }
1141
1142 # remove the original DVD image 
1143 function remove_intermediate_iso_file {
1144   [[ $keep_isofile -eq 1 ]] && return 1
1145   if [ $keep_intermediate_files -eq 0 ]; then
1146     [[ -e "$isofile" ]] && rm "$isofile"
1147   else
1148     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1149   fi
1150 }
1151
1152 # remove the intermediate dvdbackup folder
1153 function remove_intermediate_dvdbackup_folder {
1154   if [ $keep_intermediate_files -eq 0 ]; then
1155     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1156   else
1157     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1158   fi
1159 }
1160
1161 ##############################################################################################
1162 # MAIN
1163 ##############################################################################################
1164
1165 # Make a note of when this DVD rip started
1166 date=`date`
1167 echo -e "\n$date DVD rip started" >> "$logfile"
1168 echo "$cmd" >> "$logfile"
1169
1170 # Rip the DVD - Mirror Mode
1171 if [ $mirror_mode -eq 1 ]; then
1172   echo "-> Ripping DVD $dvdname to $dest"
1173
1174   # use ddrescue to make an ISO image of the disk
1175   make_dvd_iso_image "$dest/$dvdname.iso"
1176
1177   # add this video data to the mythtv DB
1178   fill_mythvideo_metadata "$dest/$dvdname.iso" 
1179
1180   # eject the disk upon completion
1181   if [ $eject_disk -ne 0 ]; then
1182     eject -T $dev
1183   fi
1184
1185   date=`date`
1186   echo "$date DVD rip completed" | tee -a "$logfile"
1187
1188   if [[ -n "$mailto" ]]; then
1189     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1190   fi
1191
1192 fi
1193
1194 # Rip the DVD - Main Title Feature Only
1195 if [ $mirror_mode -eq 0 ]; then
1196
1197   # Rip image from DVD
1198   if [ $ripdvd -eq 1 ]; then
1199     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1200     # use ddrescue to make an ISO image of the disk
1201     make_dvd_iso_image "$tmpdir/$dvdname.iso"
1202   fi
1203
1204   # Rip image from DVD path
1205   if [ -n "$dvdpath" ]; then
1206     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1207     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1208   fi
1209
1210   # make sure our isofile value is set
1211   if [ -z "$isofile" ]; then
1212     isofile="$tmpdir/$dvdname.iso"
1213   fi
1214      
1215   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1216
1217     if [ ! -e "$vobfile" ]; then
1218       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1219       
1220       # get the feature title from the ISO
1221       get_feature_title "$isofile"
1222  
1223       # get the crop value from the ISO
1224       get_crop_from_iso
1225
1226       # check for mplayer dumpstream incompatibilities
1227       # if they exist, this method will set this mode to 0.
1228       check_for_mplayer_dumpstream_incompatibility
1229
1230       if [ $use_mplayer_dumpstream -eq 1 ]; then 
1231
1232         # get our audio id from the ISO file
1233         get_audio_id_from_iso "$isofile"
1234
1235         # create our main VOB file from the ISO
1236         create_main_vob_with_mplayer "$isofile"
1237      
1238         # remove the intermediate VOB file
1239         remove_intermediate_vob_file
1240
1241         # it's possible that our VOB is still corrupted in some manner
1242         # check to make sure it is still a good VOB before continuing.
1243         check_for_mplayer_dumpstream_incompatibility
1244
1245       fi
1246  
1247       if [ $use_mplayer_dumpstream -eq 0 ]; then 
1248
1249         # use dvdbackup to make a DVD folder of the feature title
1250         make_dvdbackup_folder_image
1251   
1252         # create our main VOB file
1253         create_main_vob_with_cat
1254
1255         # get our audio id from the VOB file
1256         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1257   
1258         # check for corrupted VOB start
1259         check_vob_for_corrupted_start
1260  
1261         # check to make sure our VOB is complete
1262         check_vob_for_completeness
1263
1264         # check to make sure our VOB doesn't have too many video packets
1265         check_vob_for_too_many_video_packets
1266
1267         # check to make sure our VOB doesn't have a52 crc errors
1268         check_vob_for_a52_crc_errors
1269
1270         # remove the intermediate VOB file
1271         remove_intermediate_vob_file
1272
1273       fi
1274
1275       # remove the intermediate ISO file
1276       remove_intermediate_iso_file
1277
1278     else
1279       echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1280       # get our audio id from the VOB file
1281       get_audio_id_from_vob "$vobfile"
1282       # get the crop value from the VOB
1283       get_crop_from_vob
1284     fi
1285
1286     # eject the DVD disk since we are finished with it
1287     [ $eject_disk -eq 2 ] && eject -T $dev
1288
1289     # encode the VOB file to a compressed file format
1290     if [ $make_final_dest_comp -eq 1 ]; then
1291       echo "-> Encoding the DVD video to a compressed file" | tee -a "$logfile"
1292
1293       # determine what our bitrate needs to be if a target size was specified instead
1294       calculate_bitrate_from_target_size        
1295      
1296       # encode the vob file into a compressed file format
1297       encode_vob_file
1298
1299       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1300         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1301         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1302       else
1303         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1304         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1305       fi
1306     fi
1307
1308   # add this video data to the mythtv DB
1309   [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file" 
1310   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1311     
1312   else
1313
1314   # use dvdbackup to make a DVD folder of the feature title
1315   make_dvdbackup_folder_image
1316
1317   # cd to the feature title DVD folder
1318   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1319   if [ $? != 0 ]; then
1320     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1321   fi
1322   
1323   # create the dvd.xml file for dvdauthor
1324   create_dvdauthor_dvd_xml_file  
1325
1326   # make the final DVD folder image
1327   make_dvdauthor_folder_image
1328
1329   # add this video data to the mythtv DB
1330   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1331  
1332   # cd back to the dir we started from
1333   popd > /dev/null 2>&1
1334
1335   if [ $make_final_dest_iso -eq 1 ]; then
1336
1337     # make an iso image out of our directory
1338     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1339    
1340     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1341     if [ -s "$dest/$dvdname.iso" ]; then
1342       if [ $make_final_dest_folder -eq 0 ]; then
1343         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1344         # remove the folder of the DVD image now that we have a .iso version of it
1345         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1346       fi
1347     else
1348       # we created an empty iso file, remove it
1349       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1350       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1351       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1352     fi
1353  
1354     # add this video data to the mythtv DB
1355     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1356
1357   fi
1358
1359   fi
1360
1361   # remove the ddrescue DVD ISO image
1362   remove_intermediate_iso_file
1363
1364   # remove the tmp dvdbackup folder of the DVD image
1365   remove_intermediate_dvdbackup_folder
1366
1367   # eject the DVD disk upon completion
1368   [ $eject_disk -eq 1 ] && eject -T $dev
1369
1370   date=`date`
1371   echo "$date DVD rip completed" | tee -a "$logfile"
1372
1373   if [[ -n "$mailto" ]]; then
1374     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1375   fi
1376
1377 fi
1378
1379 ##############################################################################################